VisimBox 1.0 VisimBox 3d simulation and visualisation ToolBox

- Main Page
- Packages
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions
VisimBox.Renderer.RenderObjects.IRenderable Interface Reference

Nodes and any other object which can be rendered must implent this interface. More...

Inheritance diagram for VisimBox.Renderer.RenderObjects.IRenderable:

List of all members.

## Public Member Functions
IGeometry | GetBoundingObject ()
| Returns bounding object of the renderable item (for lights etc). Should be simplest possible (box)
Vector3 | GetCenter ()
| Fallback function if GetBoundingObject returns null.
void | OnRender (RendererEventArgs args)
| Called by the renderer when rendering hiearchy of elements. Object must either perform complete render (set transformation, material and use direct rendering calls) or feed renderbuffer of the context with correct data.
void | RenderGeometry (RendererEventArgs args)
| Feed geometry to the renderer (all other settings should be already set)

## Detailed Description

Nodes and any other object which can be rendered must implent this interface.

## Member Function Documentation

IGeometry VisimBox.Renderer.RenderObjects.IRenderable.GetBoundingObject | ( |  | ) |

Returns bounding object of the renderable item (for lights etc). Should be simplest possible (box)

Returns:
  Bounding object or null if not using one

Implemented in VisimBox.Scene.RenderableNode, and VisimBox.Scene.SkyBoxNode.

Vector3 VisimBox.Renderer.RenderObjects.IRenderable.GetCenter | ( |  | ) |

Fallback function if GetBoundingObject returns null.

Returns:
  Center of the object

Implemented in VisimBox.Scene.RenderableNode, and VisimBox.Scene.SkyBoxNode.

void VisimBox.Renderer.RenderObjects.IRenderable.OnRender | ( | RendererEventArgs | args | ) |

Called by the renderer when rendering hiearchy of elements. Object must either perform complete render (set transformation, material and use direct rendering calls) or feed renderbuffer of the context with correct data.

Parameters:

  args | Rendering events - pointer to rendering context and renderer

Direct rendering should be done only in special cases in this call as it removes any rendering optimalizations performed on the render buffer. This is important especially for any objects using alpha transparency, which could create visual artefacts unless rendered in sorter back to front order.

Implemented in VisimBox.Scene.CameraNode, VisimBox.Scene.RenderableNode, and VisimBox.Scene.SkyBoxNode.

void VisimBox.Renderer.RenderObjects.IRenderable.RenderGeometry | ( | RendererEventArgs | args | ) |

Feed geometry to the renderer (all other settings should be already set)

Parameters:

  args | Rendering events - pointer to rendering context and renderer

Used when rendering from the renderbuffer

Implemented in VisimBox.Scene.CameraNode, VisimBox.Scene.LightNode, VisimBox.Scene.RenderableNode, VisimBox.Scene.NodeMesh, and VisimBox.Scene.SkyBoxNode.

The documentation for this interface was generated from the following file:

- IRenderable.cs

All Classes Namespaces Files Functions Variables Enumerations Properties Events